# -*- python -*-
# $RCSfile: reporterIO.py,v $
# $Revision: 1.5 $
# $Author: langer $
# $Date: 2005/05/13 18:43:49 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# Routine for saving the contents of the Message Window.  It has its
# own file to avoid import loops.

from oof2.common import debug
from oof2.common.IO import mainmenu
from oof2.common.IO import oofmenu
from oof2.common.IO import parameter
from oof2.common.IO import reporter

def saveMessages(menuitem, filename, mode, **messagetypes):
    file = open(filename, mode)
    for message in reporter.messagemanager.all_messages():
        if messagetypes[message[1]]:
            print >> file, message[0]
    file.close()

mainmenu.OOF.File.Save.addItem(oofmenu.OOFMenuItem(
    "Messages",
    help="Save the message logs from the message windows to a file.",
    callback=saveMessages,
    params=[parameter.StringParameter('filename', tip="Name of the file."),
            parameter.StringParameter('mode',
                                      tip="'w' to (over)write and 'a' to append")] +
    [parameter.BooleanParameter(name, 1,
                                tip="1 (true) to include and 0 (false) to not.") for name in reporter.messageclasses],
    ordering=10000,
    discussion="Unlike other <link linkend='MenuItem:OOF.File.Save'>OOF.File.Save</link> menu varieties, messages are saved only in an <emphasis>ascii</emphasis> format for an obvious reason."))
