# -*- makefile -*- 
# $RCSfile: DIR.mk,v $
# $Revision: 1.91 $
# $Author: redwing $
# $Date: 2005/07/28 15:05:22 $


# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modifed
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

dirname := engine
subdirs := property element SparseLib++ IO 

ifeq ($(PETSCTRUE),$(TRUE))
	subdirs := $(subdirs) PETSc
endif


cfiles := boundarycond.C blockpre_double.C edge.C edgeset.C element.C \
elementnodeiterator.C equation.C eulerangle.C field.C flux.C	      \
fluxnormal.C freedom.C gausspoint.C masterelement.C material.C	      \
femesh.C mvmult.C nodalequation.C node.C property.C solver.C	      \
pypropertywrapper.C shapefunction.C shapefunctioncache.C cskeleton.C  \
stiffnessmatrix.C symmmatrix.C mastercoord.C pixelintersection.C      \
twomatrix.C preconditioner.C fieldindex.C log_value.C contourcell.C   \
ooferror.C cstrain.C pixelselectioncouriere.C outputval.C	      \
eigenvalues.C invariant.C solverdriver.C symeig3.C rank3tensor.C      \
celectricfield.C timederivative.C steppingscheme.C cscpatch.C	      \
nodalfluxes.C nodalscpatches.C recoveredflux.C csrmatrix.C	      \
timestepadapter.C subproblem.C timestepadaptermanager.C

swigfiles := boundarycond.swg contourcell.swg csrmatrix.swg	       \
edgeset.swg edge.swg elementnodeiterator.swg elements.swg equation.swg \
eulerangle.swg field.swg flux.swg freedom.swg fieldindex.swg	       \
gausspoint.swg masterelement.swg material.swg femesh.swg	       \
nodalequation.swg node.swg preconditioner.swg properties.swg	       \
pypropertywrapper.swg sparselink.swg solver.swg cskeleton.swg	       \
stiffnessmatrix.swg symmmatrix.swg vector.swg mastercoord.swg	       \
ooferror2.swg cstrain.swg pixelselectioncouriere.swg outputval.swg     \
invariant.swg planarity.swg solverdriver.swg conjugate.swg	       \
rank3tensor.swg timederivative.swg steppingscheme.swg 		       \
timestepadapter.swg subproblem.swg timestepadaptermanager.swg

pyfiles := anneal.py bdycondition.py boundary.py boundarybuilder.py   \
boundarymodifier.py builtinprops.py refinementtarget.py component.py  \
deputy.py deputyParallel.py deputytracker.py edgeswap.py	      \
fiddlenodesbase.py fiddlenodesbaseParallel.py fieldinit.py	      \
initialize.py instantnodemove.py materialmanager.py materialplugin.py \
mergetriangles.py mesh.py meshcrosssection.py pixelselect.py	      \
problem.py profile.py profilefunction.py propertyregistration.py      \
pyproperty.py rationalize.py rationalizefunctions.py rationalsharp.py \
rationalshort.py rationalwide.py refine.py refinemethod.py	      \
refinequadbisection.py skeleton.py skeletonboundary.py		      \
skeletoncontext.py skeletondiff.py skeletonelement.py		      \
skeletongroups.py skeletonmodifier.py skeletonnode.py		      \
skeletonsegment.py skeletonselectable.py skeletonselectionmethod.py   \
skeletonselectionmod.py skeletonselectionmodes.py		      \
skeletonselmodebase.py smooth.py snapnode.py splitquads.py	      \
vigilante.py meshmod.py relaxation.py analysisdomain.py		      \
analysissample.py pinnodesmodifier.py timedrivers.py		      \
adaptivemeshrefinement.py errorestimator.py revertmesh.py scpatch.py  \
problemmanager.py subproblemcontext.py interface_criteria.py

swigpyfiles := contourcell_.py csrmatrix_.py edge_.py edgeset_.py      \
elementnodeiterator_.py element_.py equation_.py eulerangle_.py	       \
field_.py flux_.py fieldindex_.py masterelement_.py material_.py       \
femesh_.py node_.py pypropertywrapper_.py sparselink_.py	       \
stiffnessmatrix_.py symmmatrix_.py vector_.py mastercoord_.py	       \
property_.py preconditioner_.py solver_.py ooferror2_.py invariant_.py \
cstrain_.py solverdriver_.py conjugate_.py outputval_.py 	       \
rank3tensor_.py steppingscheme_.py timestepadapter_.py subproblem_.py  \
timestepadaptermanager_.py

hfiles := automatrix.h boundarycond.h blockpre_double.h constraint.h  \
contourcell.h csrmatrix.h edge.h edgeset.h element.h		      \
elementnodeiterator.h equation.h eulerangle.h field.h flux.h	      \
fluxnormal.h freedom.h gausspoint.h group.h indextypes.h	      \
masterelement.h material.h matvec.h femesh.h mvmult.h nodalequation.h \
nodegroup.h node.h preconditioner.h property.h pypropertywrapper.h    \
cskeleton.h shapefunctioncache.h shapefunction.h sparselink.h	      \
stiffnessmatrix.h symmmatrix.h twovector.h mastercoord.h solver.h     \
twomatrix.h fieldindex.h log_value.h ooferror.h cstrain.h	      \
pixelselectioncouriere.h outputval.h symeig3.h eigenvalues.h	      \
invariant.h planarity.h solverdriver.h conjugate.h rank3tensor.h      \
celectricfield.h timederivative.h steppingscheme.h matrixbase.h       \
cscpatch.h nodalfluxes.h nodalscpatches.h recoveredflux.h 	      \
timestepadapter.h subproblem.h timestepadaptermanager.h

# Don't modify the rest of this
include $(SUBDIR)



