# -*- python -*-
# $RCSfile: element_.py,v $
# $Revision: 1.16 $
# $Author: langer $
# $Date: 2005/05/13 18:44:04 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov.

from oof2.SWIG.engine import mastercoord
from oof2.SWIG.engine import edge
from oof2.SWIG.common import coord
from oof2.SWIG.engine import gausspoint

### Call this function to get a Python list of edges copied out from
### C++.  The resulting list is not mirrored in the C++ code, but is
### free for you to use, destroy, whatever.
###
### Optimization:  Cache these, the way the Boundaries do?
### That would cost storage, but save time, so it might not actually
### be an optimization.
###
### And, also, the perimeter function in particular returns elements
### which should be owned by Python, which is why thisown is set to 1.
##def _Element__perimeter(self):
##    val = map(edge.EdgePtr, self.perimeter_())
##    for v in val:
##        v.thisown = 1
##    return val

##ElementPtr.perimeter = _Element__perimeter


def _Element__position(self, coords):
    return [self.from_master(c[0], c[1]) for c in coords]

ElementPtr.position = _Element__position

from oof2.SWIG.engine.masterelement import MasterElementPtr
from oof2.SWIG.common.coord import CoordPtr
from oof2.SWIG.engine.mastercoord import MasterCoordPtr
from oof2.SWIG.engine.edge import BoundaryEdgePtr

