# -*- python -*-
# $RCSfile: subproblemcontext.py,v $
# $Revision: 1.6 $
# $Author: reida $
# $Date: 2005/08/02 18:18:20 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# The Mesh class wraps the C++ FEMesh class, associating a Skeleton
# and miscellaneous bookkeeping information with it.  Mesh itself is a
# Who class, which means it can participate in the layer-display
# process.

from oof2.SWIG.common import devel
from oof2.SWIG.common import lock
from oof2.SWIG.common import ooferror
from oof2.SWIG.common import switchboard
from oof2.SWIG.common import timestamp
from oof2.SWIG.engine import equation
from oof2.SWIG.engine import field
from oof2.SWIG.engine import flux
from oof2.SWIG.engine import masterelement
from oof2.common import debug
from oof2.common import enum
from oof2.common import ringbuffer
from oof2.common import utils
from oof2.common.IO import parameter
from oof2.common.IO import whoville
import copy
import string


class SubProblemWho(whoville.Who):
    def __init__(self, name, classname, subproblem,
                 mesh=None):
        whoville.Who.__init__(self, name, classname, subproblem)
        self.mesh = mesh
        if self.mesh:
            self.mesh.getObject().addsubproblem(subproblem)

    ## def mesh(self): ## mesh is a mesh context
    ##    return self.mesh
    
    def setMesh(self, mesh): ## mesh context
        if self.mesh:
            self.mesh.getObject.remove_subproblem(self.getObject().name)
        self.mesh = mesh
        self.mesh.getObject().addsubproblem(self.getObject())
        
    def getMesh(self): ## mesh context
        return self.mesh
    
    def subproblem(self):
        return self.getObject()
    
    def destroy(self):
        global subproblems
        # TODO: The subproblem name should be locally known.
        self.mesh.getObject().remove_subproblem(self.getObject().name)
        self.mesh.remove_mesh(self)
        del self.mesh             
        self.getObject().destroy()  
        subproblems.remove(self.path())
    def autoenableBCs(self):
        self.mesh.autoenableBCs()
            
        
from oof2.engine import mesh

subproblems = whoville.WhoClass(
    'SubProblemWho',
    ordering=300,
    parentClass= mesh.meshes,
    instanceClass=SubProblemWho,
    secret = 1,
    proxyClasses=['<topmost>','<contourable>'])

utils.OOFdefine('subproblems', subproblems)
